using Insight.Infrastructure;
using Insight.Infrastructure.Entities;
using Insight.Web.Components.Containers;
using Insight.Web.Constants;
using Microsoft.AspNetCore.Components;
using MongoDB.Bson;
using MongoDB.Driver;
using MudBlazor;
using System.Text.RegularExpressions;
using SortDirection = MudBlazor.SortDirection;

namespace Insight.Web.Pages.Management.Hosts.Systems.Users;

[Route(Navigation.Management.Hosts.Systems.Users.Index)]
public partial class Index
{
    [Parameter] public string? HostId { get; set; }

    [Inject] private IMongoDatabase Database { get; init; } = default!;
    [Inject] private ISnackbar Snackbar { get; init; } = default!;
    [Inject] private NavigationManager NavigationManager { get; init; } = default!;

    private TableContainer<HostUserEntity>? Container { get; set; }
    private string Title { get; set; } = Global.Name;
    private List<BreadcrumbItem> Breadcrumbs { get; } = new();
    private string? Search { get; set; }

    protected override async Task OnInitializedAsync()
    {
        if (string.IsNullOrWhiteSpace(HostId) || ObjectId.TryParse(HostId, out var hostId) is false)
        {
            Notification.Error(Snackbar, "Not Found");
            NavigationManager.NavigateTo(Navigation.Management.Hosts.Index);
            return;
        }

        var host = await Database.Host()
            .Find(Builders<HostEntity>
            .Filter
            .Eq(p => p.Id, HostId))
            .FirstOrDefaultAsync(default);

        if (host is null)
        {
            Notification.Error(Snackbar, "Not Found");
            NavigationManager.NavigateTo(Navigation.Management.Hosts.Index);
            return;
        }

        Title = $"Hosts » {host.Name} » Users｜Insight";
        Breadcrumbs.Add(new BreadcrumbItem("Home", href: Navigation.Home));
        Breadcrumbs.Add(new BreadcrumbItem("Hosts", href: Navigation.Management.Hosts.Index));
        Breadcrumbs.Add(new BreadcrumbItem(host.Name, href: Navigation.Management.Hosts.DetailsHref(HostId)));
        Breadcrumbs.Add(new BreadcrumbItem("Users", href: "#", true));
    }

    private async Task<TableData<HostUserEntity>> LoadDataAsync(TableState state)
    {
        try
        {
            var filter = Builders<HostUserEntity>.Filter.Eq(p => p.Host, HostId);

            if (string.IsNullOrWhiteSpace(Search) is false)
            {
                var regex = new BsonRegularExpression(new Regex(Search, RegexOptions.IgnoreCase));
                filter &= Builders<HostUserEntity>.Filter.Regex(x => x.Name, regex) |
                    Builders<HostUserEntity>.Filter.Regex(x => x.FullName, regex) |
                    Builders<HostUserEntity>.Filter.Regex(x => x.Sid, regex) |
                    Builders<HostUserEntity>.Filter.Regex(x => x.Lockout, regex) |
                    //Builders<HostUserEntity>.Filter.Regex(x => x.Groups, regex) |
                    Builders<HostUserEntity>.Filter.Regex(x => x.Status, regex);
            }

            var query = Database.HostSystemUser()
                .Find(filter)
                .Sort(state.SortDirection switch
                {
                    SortDirection.Ascending => state.SortLabel switch
                    {
                        "Name" => Builders<HostUserEntity>.Sort.Ascending(p => p.Name),
                        "FullName" => Builders<HostUserEntity>.Sort.Ascending(p => p.FullName),
                        "Sid" => Builders<HostUserEntity>.Sort.Ascending(p => p.Sid),
                        "Lockout" => Builders<HostUserEntity>.Sort.Ascending(p => p.Lockout),
                        //"Groups" => Builders<HostUserEntity>.Sort.Ascending(p => p.Groups),
                        "Status" => Builders<HostUserEntity>.Sort.Ascending(p => p.Status),
                        _ => null
                    },
                    SortDirection.Descending => state.SortLabel switch
                    {
                        "Name" => Builders<HostUserEntity>.Sort.Descending(p => p.Name),
                        "FullName" => Builders<HostUserEntity>.Sort.Descending(p => p.FullName),
                        "Sid" => Builders<HostUserEntity>.Sort.Descending(p => p.Sid),
                        "Lockout" => Builders<HostUserEntity>.Sort.Descending(p => p.Lockout),
                        //"Groups" => Builders<HostUserEntity>.Sort.Descending(p => p.Groups),
                        "Status" => Builders<HostUserEntity>.Sort.Descending(p => p.Status),
                        _ => null
                    },
                    _ => Builders<HostUserEntity>.Sort.Ascending(p => p.Domain).Ascending(p => p.Name)
                });

            return new TableData<HostUserEntity>()
            {
                TotalItems = (int)await query.CountDocumentsAsync(default),
                Items = await query.Skip(state.Page * state.PageSize).Limit(state.PageSize).ToListAsync(default)
            };
        }
        catch (Exception)
        {
            Notification.Error(Snackbar);
            return new TableData<HostUserEntity>();
        }
    }
}